                   PROGRAM
                   MAP
                   END

Window WINDOW('Caption'),AT(,,503,137),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY,RESIZE
       LIST,AT(0,0),USE(?List),FULL,HVSCROLL
     END
      !LIST,AT(0,0),USE(?List),FULL,HVSCROLL,FORMAT('50L(2)|FMT~~10L(2)Y~1~@P PB@10L(2)Y~2~@P PB@10L(2)Y~3~@P PB@')

DefaultFormat      EQUATE('100L(2)|FMT~~')
LOC:Format         STRING(4096)
LOC:Width          SHORT(12)

DataQueue          QUEUE
Level                LONG
FromDate             LONG
ToDate               LONG
Color                LONG
Std                  BYTE
                   END

ViewQueue          QUEUE
Line                 STRING(4096)
                   END

Colors             SHORT,DIM(100,3)

  CODE
  OPEN(Window)
  LOC:Format = DefaultFormat
  LOOP W# = TODAY() TO TODAY()+100
    LOC:Format = CLIP(LOC:Format)&LOC:Width&'C(0)|_JY~' & DAY(W#) & '~@P PB@'
  END
  DO PrepareData
  LOOP W# = 1 TO RECORDS(DataQueue)
    GET(DataQueue, W#)
    CLEAR(ViewQueue)
    ViewQueue.Line = ' #' & FORMAT(W#,@N04)&'|'&DataQueue.Level
    LOOP Today# = TODAY() TO TODAY()+100
      EndWeek# = CHOOSE((Today# % 7)=6 OR (Today# % 7)=0,1,0)
      IF DataQueue.FromDate = Today#
        ViewQueue.Line = CLIP(ViewQueue.Line)&'|1|'&Colors[DataQueue.Color,1]&'|'&EndWeek#
      ELSIF DataQueue.ToDate = Today#
        ViewQueue.Line = CLIP(ViewQueue.Line)&'|1|'&Colors[DataQueue.Color,3]&'|'&EndWeek#
      ELSIF DataQueue.FromDate < Today# AND Today# < DataQueue.ToDate
        ViewQueue.Line = CLIP(ViewQueue.Line)&'|1|'&Colors[DataQueue.Color,2]&'|'&EndWeek#
      ELSE
        ViewQueue.Line = CLIP(ViewQueue.Line)&'|1|0|'&EndWeek#
      END
    END
    ADD(ViewQueue)
  END
  SELECT(?List,1)
  ACCEPT
  END
  CLOSE(Window)

PrepareData      ROUTINE

  ?List{PROP:Lineheight} = 12
  ?List{PROP:Format} = LOC:Format
  ?List{PROP:From} = ViewQueue
  ?List{PROPSTYLE:BackColor,1} = 0E6E6FFH
  ?List{PROPSTYLE:BackSelected,1} = 0E6E6FFH
  ?List{PROP:IconList, 1} = '~red_ext_left.ico';      Colors[1,1] =  1
  ?List{PROP:IconList, 2} = '~red_ext_center.ico';    Colors[1,2] =  2
  ?List{PROP:IconList, 3} = '~red_ext_right.ico';     Colors[1,3] =  3
  ?List{PROP:IconList, 4} = '~blue_ext_left.ico';     Colors[2,1] =  4
  ?List{PROP:IconList, 5} = '~blue_ext_center.ico';   Colors[2,2] =  5
  ?List{PROP:IconList, 6} = '~blue_ext_right.ico';    Colors[2,3] =  6
  ?List{PROP:IconList, 7} = '~green_ext_left.ico';    Colors[3,1] =  7
  ?List{PROP:IconList, 8} = '~green_ext_center.ico';  Colors[3,2] =  8
  ?List{PROP:IconList, 9} = '~green_ext_right.ico';   Colors[3,3] =  9
  ?List{PROP:IconList,10} = '~yellow_ext_left.ico';   Colors[4,1] = 10
  ?List{PROP:IconList,11} = '~yellow_ext_center.ico'; Colors[4,2] = 11
  ?List{PROP:IconList,12} = '~yellow_ext_right.ico';  Colors[4,3] = 12
  ?List{PROP:IconList,13} = '~red1_ext_left.ico';     Colors[5,1] = 13
  ?List{PROP:IconList,14} = '~red1_ext_center.ico';   Colors[5,2] = 14
  ?List{PROP:IconList,15} = '~red1_ext_right.ico';    Colors[5,3] = 15

  Today# = TODAY()
  DataQueue.Level = 1
  DataQueue.FromDate = Today# + 1
  DataQueue.ToDate = Today# + 5
  DataQueue.Color = 1
  ADD(DataQueue)
  DataQueue.Level = 2
  DataQueue.FromDate = Today# + 3
  DataQueue.ToDate = Today# + 7
  DataQueue.Color = 2
  ADD(DataQueue)
  DataQueue.Level = 1
  DataQueue.FromDate = Today# + 8
  DataQueue.ToDate = Today# + 50
  DataQueue.Color = 3
  ADD(DataQueue)
  DataQueue.Level = 2
  DataQueue.FromDate = Today# + 7
  DataQueue.ToDate = Today# + 20
  DataQueue.Color = 4
  ADD(DataQueue)
  DataQueue.Level = 1
  DataQueue.FromDate = Today# + 15
  DataQueue.ToDate = Today# + 20
  DataQueue.Color = 5
  ADD(DataQueue)
  DataQueue.Level = 1
  DataQueue.FromDate = Today# + 3
  DataQueue.ToDate = Today# + 9
  DataQueue.Color = 1
  ADD(DataQueue)
  DataQueue.Level = 1
  DataQueue.FromDate = Today# + 4
  DataQueue.ToDate = Today# + 24
  DataQueue.Color = 2
  ADD(DataQueue)
  DataQueue.Level = 1
  DataQueue.FromDate = Today# + 12
  DataQueue.ToDate = Today# + 40
  DataQueue.Color = 3
  ADD(DataQueue)
  DataQueue.Level = 2
  DataQueue.FromDate = Today# + 15
  DataQueue.ToDate = Today# + 30
  DataQueue.Color = 4
  ADD(DataQueue)
  DataQueue.Level = 3
  DataQueue.FromDate = Today# + 2
  DataQueue.ToDate = Today# + 6
  DataQueue.Color = 5
  ADD(DataQueue)
